﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Problems.Scheduling.Interfaces;

namespace HeuristicLab.Problems.Scheduling.Encodings {
  [Item("JSSPManipulator", "A JSSP manipulation operation.")]
  [StorableClass]
  public abstract class JSSPManipulator : SchedulingOperator, IJSSPManipulator {
    #region IJSSPManipulator Members

    public ILookupParameter<JSSPEncoding> SchedulingSolutionParameter {
      get { return (ILookupParameter<JSSPEncoding>)Parameters["SchedulingSolution"]; }
    }

    #endregion

    [StorableConstructor]
    protected JSSPManipulator(bool deserializing) : base(deserializing) { }
    protected JSSPManipulator(JSSPManipulator original, Cloner cloner)
      : base(original, cloner) {
    }
    public JSSPManipulator()
      : base() {
        Parameters.Add(new LookupParameter<JSSPEncoding>("SchedulingEncoding", "The JSSP solution to be manipulated."));
    }

  }
}
